import { Component, Directive, NgModule, ViewEncapsulation } from "@angular/core";
import { IgxButtonModule } from "../button/button.directive";
/**
 * IgxCardHeader is container for the card header
 */
var IgxCardHeader = /** @class */ (function () {
    function IgxCardHeader() {
    }
    IgxCardHeader.decorators = [
        { type: Directive, args: [{
                    selector: "igx-card-header"
                },] },
    ];
    /** @nocollapse */
    IgxCardHeader.ctorParameters = function () { return []; };
    return IgxCardHeader;
}());
export { IgxCardHeader };
/**
 * IgxCardContent is container for the card content
 */
var IgxCardContent = /** @class */ (function () {
    function IgxCardContent() {
    }
    IgxCardContent.decorators = [
        { type: Directive, args: [{
                    selector: "igx-card-content"
                },] },
    ];
    /** @nocollapse */
    IgxCardContent.ctorParameters = function () { return []; };
    return IgxCardContent;
}());
export { IgxCardContent };
/**
 * IgxCardActions is container for the card actions
 */
var IgxCardActions = /** @class */ (function () {
    function IgxCardActions() {
    }
    IgxCardActions.decorators = [
        { type: Directive, args: [{
                    selector: "igx-card-actions"
                },] },
    ];
    /** @nocollapse */
    IgxCardActions.ctorParameters = function () { return []; };
    return IgxCardActions;
}());
export { IgxCardActions };
/**
 * IgxCardFooter is container for the card footer
 */
var IgxCardFooter = /** @class */ (function () {
    function IgxCardFooter() {
    }
    IgxCardFooter.decorators = [
        { type: Directive, args: [{
                    host: {
                        role: "footer"
                    },
                    selector: "igx-card-footer"
                },] },
    ];
    /** @nocollapse */
    IgxCardFooter.ctorParameters = function () { return []; };
    return IgxCardFooter;
}());
export { IgxCardFooter };
/**
 * IgxCardComponent is a sheet of material that serves as an entry point to more detailed information.
 */
var IgxCardComponent = /** @class */ (function () {
    function IgxCardComponent() {
    }
    IgxCardComponent.decorators = [
        { type: Component, args: [{
                    encapsulation: ViewEncapsulation.None,
                    selector: "igx-card",
                    styles: [".igx-card{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-flow:row wrap;flex-flow:row wrap;-webkit-box-shadow:0 1px 5px 0 rgba(0,0,0,0.26),0 2px 2px 0 rgba(0,0,0,0.12),0 3px 1px -2px rgba(0,0,0,0.08);box-shadow:0 1px 5px 0 rgba(0,0,0,0.26),0 2px 2px 0 rgba(0,0,0,0.12),0 3px 1px -2px rgba(0,0,0,0.08);overflow:hidden;border-radius:2px;background:#fff;-webkit-transition:-webkit-box-shadow 0.3s cubic-bezier(0.25, 0.8, 0.25, 1);transition:-webkit-box-shadow 0.3s cubic-bezier(0.25, 0.8, 0.25, 1);-o-transition:box-shadow 0.3s cubic-bezier(0.25, 0.8, 0.25, 1);transition:box-shadow 0.3s cubic-bezier(0.25, 0.8, 0.25, 1);transition:box-shadow 0.3s cubic-bezier(0.25, 0.8, 0.25, 1), -webkit-box-shadow 0.3s cubic-bezier(0.25, 0.8, 0.25, 1);-webkit-backface-visibility:hidden;backface-visibility:hidden}.igx-card:hover{-webkit-box-shadow:0 5px 5px -3px rgba(0,0,0,0.26),0 8px 10px 1px rgba(0,0,0,0.12),0 3px 14px 2px rgba(0,0,0,0.08);box-shadow:0 5px 5px -3px rgba(0,0,0,0.26),0 8px 10px 1px rgba(0,0,0,0.12),0 3px 14px 2px rgba(0,0,0,0.08)}.igx-card igx-card-header{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-flow:row wrap;flex-flow:row wrap;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-ms-flex-preferred-size:100%;flex-basis:100%;padding:1.5em 1em 1em 1em}.igx-card-header--compact,.igx-card igx-card-header.compact{padding:1em}.igx-card-header__title,.igx-card-header__title--small{margin:0;-ms-flex-preferred-size:100%;flex-basis:100%;font-size:1.5em;line-height:1.5em}.igx-card-header__title--small{font-size:.875em}.igx-card-header__subtitle{margin:0;color:rgba(0,0,0,0.54);font-size:.875em;line-height:1.5em}.igx-card igx-card-content{-ms-flex-preferred-size:100%;flex-basis:100%;padding:1em}.igx-card-content__text{margin:0;color:rgba(0,0,0,0.54);font-size:.875em;line-height:20px,16px}.igx-card__media{width:auto;margin-right:auto;-webkit-box-ordinal-group:0;-ms-flex-order:-1;order:-1}.igx-card__media--right{width:auto;margin-left:auto;-webkit-box-ordinal-group:10000;-ms-flex-order:9999;order:9999}.igx-card igx-card-actions{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-flow:row wrap;flex-flow:row wrap;-webkit-box-flex:1;-ms-flex:1 0 auto;flex:1 0 auto;-webkit-box-align:center;-ms-flex-align:center;align-items:center;padding:.5em;max-height:56px}.igx-card-actions__bgroup{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-flow:row nowrap;flex-flow:row nowrap}.igx-card-actions__bgroup [igxButton] ~ [igxButton]{margin-left:8px}.igx-card-actions__igroup,.igx-card-actions__igroup--start,.igx-card-actions__igroup--end{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-ms-flex-flow:row nowrap;flex-flow:row nowrap;color:rgba(0,0,0,0.54)}.igx-card-actions__igroup--start{margin-right:auto}.igx-card-actions__igroup--end{margin-left:auto}.igx-card-header__tgroup{margin:0 1em}"],
                    template: "<div class=\"igx-card\" role=\"group\">     <ng-content></ng-content> </div>"
                },] },
    ];
    /** @nocollapse */
    IgxCardComponent.ctorParameters = function () { return []; };
    return IgxCardComponent;
}());
export { IgxCardComponent };
var IgxCardModule = /** @class */ (function () {
    function IgxCardModule() {
    }
    IgxCardModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [IgxCardComponent, IgxCardHeader, IgxCardContent, IgxCardActions, IgxCardFooter],
                    exports: [IgxCardComponent, IgxCardHeader, IgxCardContent, IgxCardActions, IgxCardFooter],
                    imports: [IgxButtonModule]
                },] },
    ];
    /** @nocollapse */
    IgxCardModule.ctorParameters = function () { return []; };
    return IgxCardModule;
}());
export { IgxCardModule };
//# sourceMappingURL=card.component.js.map