import { NavigationService } from "./nav-service";
/**
 * Directive that can toggle targets through provided NavigationService.
 *
 * Usage:
 * ```
 * <button igxNavToggle="ID"> Toggle </button>
 * ```
 * Where the `ID` matches the ID of compatible `IToggleView` component.
 */
export declare class NavigationToggle {
    state: NavigationService;
    private target;
    constructor(nav: NavigationService);
    toggleNavigationDrawer(): void;
}
/**
 * Directive that can close targets through provided NavigationService.
 *
 * Usage:
 * ```
 * <button igxNavClose="ID"> Close </button>
 * ```
 * Where the `ID` matches the ID of compatible `IToggleView` component.
 */
export declare class NavigationClose {
    state: NavigationService;
    private target;
    constructor(nav: NavigationService);
    closeNavigationDrawer(): void;
}
export declare class IgxNavigationDirectives {
}
