import { Subject } from "rxjs/Subject";
import { SortingDirection } from "../data-operations/sorting-expression.interface";
import { IgxGridCellComponent } from "./cell.component";
import { IgxColumnComponent } from "./column.component";
import { IgxGridComponent } from "./grid.component";
import { IgxGridRowComponent } from "./row.component";
export declare class IgxGridAPIService {
    change: Subject<any>;
    protected state: Map<string, IgxGridComponent>;
    register(grid: IgxGridComponent): void;
    get(id: string): IgxGridComponent;
    markForCheck(id: string): void;
    get_column_by_name(id: string, name: string): IgxColumnComponent;
    get_row(id: string, index: number): IgxGridRowComponent;
    get_cell_by_field(id: string, rowIndex: number, field: string): IgxGridCellComponent;
    get_cell_by_index(id: string, rowIndex: number, columnIndex: number): IgxGridCellComponent;
    update(id: string, cell: IgxGridCellComponent): void;
    updateRow(value: any, id: string, row: IgxGridRowComponent): void;
    sort(id: string, fieldName: string, dir: SortingDirection): void;
    sort_multiple(id: string, expressions: any): void;
    filter(id: any, fieldName: any, term: any, condition: any, ignoreCase: any): void;
    filterGlobal(id: any, term: any, condition: any, ignoreCase: any): void;
    clear_filter(id: any, fieldName: any): void;
    protected prepare_filtering_expression(state: any, fieldName: any, searchVal: any, condition: any, ignoreCase: any): void;
    protected prepare_sorting_expression(state: any, fieldName: any, dir: any): void;
}
