import { AfterContentInit, ChangeDetectorRef, TemplateRef } from "@angular/core";
import { DataType } from "../data-operations/data-util";
import { IgxGridAPIService } from "./api.service";
import { IgxCellFooterTemplateDirective, IgxCellHeaderTemplateDirective, IgxCellTemplateDirective } from "./grid.common";
export declare class IgxColumnComponent implements AfterContentInit {
    private gridAPI;
    private cdr;
    field: string;
    header: string;
    sortable: boolean;
    editable: boolean;
    filterable: boolean;
    hidden: boolean;
    movable: boolean;
    width: string;
    headerClasses: string;
    cellClasses: string;
    index: number;
    formatter: (value: any) => any;
    filteringCondition: (target: any, searchVal: any, ignoreCase?: boolean) => boolean;
    filteringIgnoreCase: boolean;
    dataType: DataType;
    gridID: string;
    bodyTemplate: TemplateRef<any>;
    headerTemplate: TemplateRef<any>;
    footerTemplate: TemplateRef<any>;
    inlineEditorTemplate: TemplateRef<any>;
    protected _bodyTemplate: TemplateRef<any>;
    protected _headerTemplate: TemplateRef<any>;
    protected _footerTemplate: TemplateRef<any>;
    protected _inlineEditorTemplate: TemplateRef<any>;
    protected _hidden: boolean;
    protected _index: number;
    protected cellTemplate: IgxCellTemplateDirective;
    protected headTemplate: IgxCellHeaderTemplateDirective;
    protected footTemplate: IgxCellFooterTemplateDirective;
    constructor(gridAPI: IgxGridAPIService, cdr: ChangeDetectorRef);
    ngAfterContentInit(): void;
    protected check(): void;
}
