import { AfterContentInit, ChangeDetectorRef, ComponentFactoryResolver, EventEmitter, OnInit, QueryList, TemplateRef, ViewContainerRef } from "@angular/core";
import { DataType } from "../data-operations/data-util";
import { FilteringLogic } from "../data-operations/filtering-expression.interface";
import { SortingDirection } from "../data-operations/sorting-expression.interface";
import { IgxGridAPIService } from "./api.service";
import { IgxGridCellComponent } from "./cell.component";
import { IgxColumnComponent } from "./column.component";
import { IgxGridRowComponent } from "./row.component";
export declare class IgxGridComponent implements OnInit, AfterContentInit {
    private gridAPI;
    cdr: ChangeDetectorRef;
    private resolver;
    private viewRef;
    data: any[];
    autoGenerate: boolean;
    id: string;
    filteringLogic: FilteringLogic;
    filteringExpressions: any[];
    paging: boolean;
    page: number;
    perPage: number;
    paginationTemplate: TemplateRef<any>;
    height: any;
    width: any;
    evenRowCSS: string;
    oddRowCSS: string;
    onSelection: EventEmitter<{}>;
    onColumnInit: EventEmitter<{}>;
    onSorting: EventEmitter<{}>;
    onFiltering: EventEmitter<{}>;
    onPaging: EventEmitter<{}>;
    onRowAdded: EventEmitter<{}>;
    onRowDeleted: EventEmitter<{}>;
    columnList: QueryList<IgxColumnComponent>;
    rowList: QueryList<IgxGridRowComponent>;
    tabindex: number;
    hostClass: string;
    hostRole: string;
    readonly pipeTrigger: number;
    sortingExpressions: any[];
    pagingState: any;
    cellInEditMode: IgxGridCellComponent;
    protected _perPage: number;
    protected _page: number;
    protected _paging: boolean;
    protected _pipeTrigger: number;
    protected _columns: any[];
    protected _filteringLogic: FilteringLogic;
    protected _filteringExpressions: any[];
    protected _sortingExpressions: any[];
    private sub$;
    constructor(gridAPI: IgxGridAPIService, cdr: ChangeDetectorRef, resolver: ComponentFactoryResolver, viewRef: ViewContainerRef);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    readonly columns: IgxColumnComponent[];
    getColumnByName(name: string): IgxColumnComponent;
    readonly visibleColumns: IgxColumnComponent[];
    getCellByColumn(rowIndex: number, columnField: string): IgxGridCellComponent;
    readonly totalPages: number;
    readonly totalRecords: number;
    readonly isFirstPage: boolean;
    readonly isLastPage: boolean;
    nextPage(): void;
    previousPage(): void;
    paginate(val: number): void;
    markForCheck(): void;
    addRow(data: any): void;
    deleteRow(rowIndex: number): void;
    updateCell(value: any, rowIndex: number, column: string): void;
    updateRow(value: any, rowIndex: number): void;
    sort(name: string, direction?: SortingDirection): void;
    sortMultiple(exprArray: any): void;
    filter(name: string, value: any, condition?: any, ignoreCase?: any): void;
    filterGlobal(value: any, condition?: any, ignoreCase?: any): void;
    clearFilter(name: string): void;
    clearFilterAll(): void;
    readonly hasSortableColumns: boolean;
    readonly hasEditableColumns: boolean;
    readonly hasFilterableColumns: boolean;
    readonly selectedCells: IgxGridCellComponent[] | any[];
    protected resolveDataTypes(rec: any): DataType;
    protected autogenerateColumns(): void;
}
