import { CommonModule } from "@angular/common";
import { Directive, ElementRef, HostBinding, HostListener, NgModule } from "@angular/core";
var IgxInputClass = /** @class */ (function () {
    function IgxInputClass(el) {
        this.el = el;
        this.isInput = true;
        this.focused = false;
        this.filled = false;
        this.placeholder = false;
    }
    IgxInputClass.prototype.onFocus = function (event) {
        this.focused = true;
    };
    IgxInputClass.prototype.onBlur = function (event) {
        this.focused = false;
    };
    IgxInputClass.prototype.ngDoCheck = function () {
        var value = this.el.nativeElement.value;
        this.filled = value && (value !== "");
        this.placeholder = this.el.nativeElement.getAttribute("placeholder") && !this.filled;
    };
    IgxInputClass.decorators = [
        { type: Directive, args: [{
                    selector: "[igxInput]"
                },] },
    ];
    /** @nocollapse */
    IgxInputClass.ctorParameters = function () { return [
        { type: ElementRef, },
    ]; };
    IgxInputClass.propDecorators = {
        "isInput": [{ type: HostBinding, args: ["class.igx-form-group__input",] },],
        "focused": [{ type: HostBinding, args: ["class.igx-form-group__input--focused",] },],
        "filled": [{ type: HostBinding, args: ["class.igx-form-group__input--filled",] },],
        "placeholder": [{ type: HostBinding, args: ["class.igx-form-group__input--placeholder",] },],
        "onFocus": [{ type: HostListener, args: ["focus", ["$event"],] },],
        "onBlur": [{ type: HostListener, args: ["blur", ["$event"],] },],
    };
    return IgxInputClass;
}());
export { IgxInputClass };
var IgxInput = /** @class */ (function () {
    function IgxInput() {
    }
    IgxInput.decorators = [
        { type: NgModule, args: [{
                    declarations: [IgxInputClass],
                    exports: [IgxInputClass],
                    imports: [CommonModule]
                },] },
    ];
    /** @nocollapse */
    IgxInput.ctorParameters = function () { return []; };
    return IgxInput;
}());
export { IgxInput };
//# sourceMappingURL=input.directive.js.map