var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { CommonModule } from "@angular/common";
import { Component, ElementRef, EventEmitter, Input, NgModule, Output, Renderer2, ViewChild } from "@angular/core";
var BaseProgress = /** @class */ (function () {
    function BaseProgress() {
        this.requestAnimationId = undefined;
        this._valueInPercent = 0;
        this._max = 100;
        this._value = 0;
        this._animate = true;
    }
    Object.defineProperty(BaseProgress.prototype, "valueInPercent", {
        get: function () {
            return this._valueInPercent;
        },
        set: function (valInPercent) {
            var valueInRange = getValueInProperRange(valInPercent, this._max);
            var valueIntoPercentage = convertInPercentage(valueInRange, this._max);
            this._valueInPercent = valueIntoPercentage;
        },
        enumerable: true,
        configurable: true
    });
    BaseProgress.prototype.runAnimation = function (val) {
        var _this = this;
        var direction = this.directionFlow(this._value, val);
        if (!this.requestAnimationId) {
            this.requestAnimationId = requestAnimationFrame(function () { return _this.updateProgressSmoothly.call(_this, val, direction); });
        }
    };
    BaseProgress.prototype.updateProgressSmoothly = function (val, direction) {
        var _this = this;
        if (this._value === val) {
            this.requestAnimationId = undefined;
            return;
        }
        this._value += direction;
        this.valueInPercent = this._value;
        requestAnimationFrame(function () { return _this.updateProgressSmoothly.call(_this, val, direction); });
    };
    BaseProgress.prototype.updateProgressDirectly = function (val) {
        this._value = val;
        this.valueInPercent = this._value;
    };
    BaseProgress.prototype.directionFlow = function (currentValue, prevValue) {
        if (currentValue < prevValue) {
            return 1;
        }
        return -1;
    };
    return BaseProgress;
}());
export { BaseProgress };
var IgxLinearProgressBar = /** @class */ (function (_super) {
    __extends(IgxLinearProgressBar, _super);
    function IgxLinearProgressBar(elementRef) {
        var _this = _super.call(this) || this;
        _this.elementRef = elementRef;
        _this.striped = false;
        _this.type = "default";
        _this.onProgressChanged = new EventEmitter();
        return _this;
    }
    Object.defineProperty(IgxLinearProgressBar.prototype, "animate", {
        get: function () {
            return this._animate;
        },
        set: function (animate) {
            this._animate = animate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLinearProgressBar.prototype, "max", {
        get: function () {
            return this._max;
        },
        set: function (maxNum) {
            this._max = maxNum;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLinearProgressBar.prototype, "value", {
        get: function () {
            return this._value;
        },
        set: function (val) {
            if (this._value === val) {
                return;
            }
            var valueInRange = getValueInProperRange(val, this.max);
            var changedValues = {
                currentValue: valueInRange,
                previousValue: this._value
            };
            if (this._animate) {
                _super.prototype.runAnimation.call(this, valueInRange);
            }
            else {
                _super.prototype.updateProgressDirectly.call(this, valueInRange);
            }
            this.onProgressChanged.emit(changedValues);
        },
        enumerable: true,
        configurable: true
    });
    IgxLinearProgressBar.decorators = [
        { type: Component, args: [{
                    selector: "igx-linear-bar",
                    styles: [".progress-linear{display:-webkit-box;display:-ms-flexbox;display:flex;position:relative;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-webkit-box-pack:start;-ms-flex-pack:start;justify-content:flex-start;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-flow:column nowrap;flex-flow:column nowrap;width:100%;height:5px;margin-bottom:32px;background:rgba(3,117,190,0.1)}.progress-linear__bar,.progress-linear__bar--default,.progress-linear__bar--danger,.progress-linear__bar--warning,.progress-linear__bar--info,.progress-linear__bar--success{width:inherit;height:inherit;-ms-flex-item-align:start;align-self:flex-start}.progress-linear--striped>div{background-image:-webkit-linear-gradient(45deg, rgba(255,255,255,0.5) 25%, transparent 25%, transparent 50%, rgba(255,255,255,0.5) 50%, rgba(255,255,255,0.5) 75%, transparent 75%, transparent);background-image:-o-linear-gradient(45deg, rgba(255,255,255,0.5) 25%, transparent 25%, transparent 50%, rgba(255,255,255,0.5) 50%, rgba(255,255,255,0.5) 75%, transparent 75%, transparent);background-image:linear-gradient(45deg, rgba(255,255,255,0.5) 25%, transparent 25%, transparent 50%, rgba(255,255,255,0.5) 50%, rgba(255,255,255,0.5) 75%, transparent 75%, transparent);background-size:40px 40px}.progress-linear__value{margin:10px 5px;position:absolute;color:rgba(0,0,0,0.74);font-size:.875em;-ms-flex-item-align:start;align-self:flex-start;font-weight:600}.progress-linear__bar--default{background-color:#0375be}.progress-linear__bar--danger{background-color:#f44336}.progress-linear__bar--warning{background-color:#fbb13c}.progress-linear__bar--info{background-color:#e41c77}.progress-linear__bar--success{background-color:#4caf50}.progress-circular{width:100%;height:100%}.progress-circular__innercircle{stroke-width:4;fill:transparent;stroke:#0375be;stroke-opacity:.1}.progress-circular__circle{fill:transparent;stroke:url(\"#linear\");stroke-width:6;stroke-linecap:round;stroke-dashoffset:289;stroke-dasharray:289;-webkit-transform-origin:50% 50%;-ms-transform-origin:50% 50%;transform-origin:50% 50%;-webkit-transform:rotate(-90deg);-ms-transform:rotate(-90deg);transform:rotate(-90deg)}.progress-circular__text{font-family:'Titillium Web', sans-serif;font-size:2em;fill:rgba(0,0,0,0.74)}"],
                    template: "<div class=\"progress-linear\"     [class.progress-linear--striped]=\"striped\">     <div #linearBar role=\"progressbar\" class=\"progress-linear__bar{{type ? '--' + type : ''}}\"         aria-valuemin=\"0\"         [attr.aria-valuemax]=\"max\"         [attr.aria-valuenow]=\"value\"         [style.width.%]=\"valueInPercent\">         <ng-content></ng-content>     </div>     <span class=\"progress-linear__value\">{{valueInPercent}}%</span> </div>"
                },] },
    ];
    /** @nocollapse */
    IgxLinearProgressBar.ctorParameters = function () { return [
        { type: ElementRef, },
    ]; };
    IgxLinearProgressBar.propDecorators = {
        "striped": [{ type: Input },],
        "type": [{ type: Input },],
        "animate": [{ type: Input },],
        "max": [{ type: Input },],
        "value": [{ type: Input },],
        "onProgressChanged": [{ type: Output },],
    };
    return IgxLinearProgressBar;
}(BaseProgress));
export { IgxLinearProgressBar };
var IgxCircularProgressBar = /** @class */ (function (_super) {
    __extends(IgxCircularProgressBar, _super);
    function IgxCircularProgressBar(elementRef, renderer) {
        var _this = _super.call(this) || this;
        _this.elementRef = elementRef;
        _this.renderer = renderer;
        _this.onProgressChanged = new EventEmitter();
        _this.STROKE_OPACITY_DVIDER = 100;
        _this.STROKE_OPACITY_ADDITION = .2;
        _this._radius = 0;
        return _this;
    }
    Object.defineProperty(IgxCircularProgressBar.prototype, "animate", {
        get: function () {
            return this._animate;
        },
        set: function (animate) {
            this._animate = animate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxCircularProgressBar.prototype, "max", {
        get: function () {
            return this._max;
        },
        set: function (maxNum) {
            this._max = maxNum;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxCircularProgressBar.prototype, "value", {
        get: function () {
            return this._value;
        },
        set: function (val) {
            if (this._value === val) {
                return;
            }
            var valueInProperRange = getValueInProperRange(val, this.max);
            var changedValues = {
                currentValue: valueInProperRange,
                previousValue: this._value
            };
            if (this.animate) {
                _super.prototype.runAnimation.call(this, valueInProperRange);
            }
            else {
                this.updateProgressDirectly(valueInProperRange);
            }
            this.onProgressChanged.emit(changedValues);
        },
        enumerable: true,
        configurable: true
    });
    IgxCircularProgressBar.prototype.ngAfterViewInit = function () {
        this._radius = parseInt(this._svgCircle.nativeElement.getAttribute("r"), 10);
        this._circumference = 2 * Math.PI * this._radius;
    };
    IgxCircularProgressBar.prototype.updateProgressSmoothly = function (val, direction) {
        // Set frames for the animation
        var FRAMES = [{
                strokeDashoffset: this.getProgress(this._value),
                strokeOpacity: (this._value / this.STROKE_OPACITY_DVIDER) + this.STROKE_OPACITY_ADDITION
            }, {
                strokeDashoffset: this.getProgress(this.valueInPercent),
                strokeOpacity: (this.valueInPercent / this.STROKE_OPACITY_DVIDER) + this.STROKE_OPACITY_ADDITION
            }];
        this._svgCircle.nativeElement.animate(FRAMES, {
            easing: "ease-out",
            fill: "forwards"
        });
        _super.prototype.updateProgressSmoothly.call(this, val, direction);
    };
    IgxCircularProgressBar.prototype.updateProgressDirectly = function (val) {
        _super.prototype.updateProgressDirectly.call(this, val);
        this.renderer.setStyle(this._svgCircle.nativeElement, "stroke-dashoffset", this.getProgress(this.valueInPercent));
        this.renderer.setStyle(this._svgCircle.nativeElement, "stroke-opacity", (this.valueInPercent / this.STROKE_OPACITY_DVIDER) + this.STROKE_OPACITY_ADDITION);
    };
    IgxCircularProgressBar.prototype.getProgress = function (percentage) {
        return this._circumference - (percentage * this._circumference / 100);
    };
    IgxCircularProgressBar.decorators = [
        { type: Component, args: [{
                    selector: "igx-circular-bar",
                    styles: [".progress-linear{display:-webkit-box;display:-ms-flexbox;display:flex;position:relative;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-webkit-box-pack:start;-ms-flex-pack:start;justify-content:flex-start;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-flow:column nowrap;flex-flow:column nowrap;width:100%;height:5px;margin-bottom:32px;background:rgba(3,117,190,0.1)}.progress-linear__bar,.progress-linear__bar--default,.progress-linear__bar--danger,.progress-linear__bar--warning,.progress-linear__bar--info,.progress-linear__bar--success{width:inherit;height:inherit;-ms-flex-item-align:start;align-self:flex-start}.progress-linear--striped>div{background-image:-webkit-linear-gradient(45deg, rgba(255,255,255,0.5) 25%, transparent 25%, transparent 50%, rgba(255,255,255,0.5) 50%, rgba(255,255,255,0.5) 75%, transparent 75%, transparent);background-image:-o-linear-gradient(45deg, rgba(255,255,255,0.5) 25%, transparent 25%, transparent 50%, rgba(255,255,255,0.5) 50%, rgba(255,255,255,0.5) 75%, transparent 75%, transparent);background-image:linear-gradient(45deg, rgba(255,255,255,0.5) 25%, transparent 25%, transparent 50%, rgba(255,255,255,0.5) 50%, rgba(255,255,255,0.5) 75%, transparent 75%, transparent);background-size:40px 40px}.progress-linear__value{margin:10px 5px;position:absolute;color:rgba(0,0,0,0.74);font-size:.875em;-ms-flex-item-align:start;align-self:flex-start;font-weight:600}.progress-linear__bar--default{background-color:#0375be}.progress-linear__bar--danger{background-color:#f44336}.progress-linear__bar--warning{background-color:#fbb13c}.progress-linear__bar--info{background-color:#e41c77}.progress-linear__bar--success{background-color:#4caf50}.progress-circular{width:100%;height:100%}.progress-circular__innercircle{stroke-width:4;fill:transparent;stroke:#0375be;stroke-opacity:.1}.progress-circular__circle{fill:transparent;stroke:url(\"#linear\");stroke-width:6;stroke-linecap:round;stroke-dashoffset:289;stroke-dasharray:289;-webkit-transform-origin:50% 50%;-ms-transform-origin:50% 50%;transform-origin:50% 50%;-webkit-transform:rotate(-90deg);-ms-transform:rotate(-90deg);transform:rotate(-90deg)}.progress-circular__text{font-family:'Titillium Web', sans-serif;font-size:2em;fill:rgba(0,0,0,0.74)}"],
                    template: "<svg #svg class=\"progress-circular\"      xmlns=\"http://www.w3.org/2000/svg\"      xmlns:xlink=\"http://www.w3.org/1999/xlink\" version=\"1.1\"      viewBox=\"0 0 100 100\" preserveAspectRatio=\"none\"     role=\"progressbar\"     aria-valuemin=\"0\"     [attr.aria-valuemax]=\"max\"     [attr.aria-valuenow]=\"value\">     <defs>         <linearGradient id=\"linear\" x1=\"-10%\" y1=\"0%\" x2=\"50%\" y2=\"150%\">         <stop offset=\"0%\"   stop-color=\"#0375BE\"/>         <stop offset=\"100%\" stop-color=\"cyan\"/>         </linearGradient>     </defs>     <circle class=\"progress-circular__innercircle\" cx=\"50\" cy=\"50\" r=\"46\"/>     <circle #circle class=\"progress-circular__circle\" cx=\"50\" cy=\"50\" r=\"46\"/>     <text #text class=\"progress-circular__text\" id=\"myTimer\" text-anchor=\"middle\" x=\"50\" y=\"60\">         {{valueInPercent}}%     </text> </svg>"
                },] },
    ];
    /** @nocollapse */
    IgxCircularProgressBar.ctorParameters = function () { return [
        { type: ElementRef, },
        { type: Renderer2, },
    ]; };
    IgxCircularProgressBar.propDecorators = {
        "onProgressChanged": [{ type: Output },],
        "animate": [{ type: Input },],
        "max": [{ type: Input },],
        "value": [{ type: Input },],
        "_svgCircle": [{ type: ViewChild, args: ["circle",] },],
        "_svgText": [{ type: ViewChild, args: ["text",] },],
    };
    return IgxCircularProgressBar;
}(BaseProgress));
export { IgxCircularProgressBar };
export function getValueInProperRange(value, max, min) {
    if (min === void 0) { min = 0; }
    return Math.max(Math.min(value, max), min);
}
export function convertInPercentage(value, max) {
    return Math.floor(100 * value / max);
}
var IgxProgressBarModule = /** @class */ (function () {
    function IgxProgressBarModule() {
    }
    IgxProgressBarModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [IgxLinearProgressBar, IgxCircularProgressBar],
                    exports: [IgxLinearProgressBar, IgxCircularProgressBar],
                    imports: [CommonModule]
                },] },
    ];
    /** @nocollapse */
    IgxProgressBarModule.ctorParameters = function () { return []; };
    return IgxProgressBarModule;
}());
export { IgxProgressBarModule };
//# sourceMappingURL=progressbar.component.js.map