import { Component, EventEmitter, Input, NgModule, Output, ViewChild } from "@angular/core";
import { NG_VALUE_ACCESSOR } from "@angular/forms";
var nextId = 0;
var noop = function () { };
var ɵ0 = noop;
var IgxRadio = /** @class */ (function () {
    function IgxRadio() {
        this.id = "igx-radio-" + nextId++;
        this.tabindex = null;
        this.change = new EventEmitter();
        this._onTouchedCallback = noop;
        this._onChangeCallback = noop;
    }
    Object.defineProperty(IgxRadio.prototype, "checked", {
        get: function () {
            return this._checked;
        },
        set: function (value) {
            this._checked = value;
        },
        enumerable: true,
        configurable: true
    });
    IgxRadio.prototype.onChange = function (event) {
        this.select();
        this.change.emit(event);
    };
    IgxRadio.prototype.select = function () {
        this.checked = true;
        this._onChangeCallback(this.value);
    };
    IgxRadio.prototype.writeValue = function (value) {
        this._value = value;
        this.checked = (this._value === this.value);
    };
    IgxRadio.prototype.onFocus = function (event) {
        this.focused = true;
    };
    IgxRadio.prototype.onBlur = function (event) {
        this.focused = false;
        this._onTouchedCallback();
    };
    IgxRadio.prototype.registerOnChange = function (fn) { this._onChangeCallback = fn; };
    IgxRadio.prototype.registerOnTouched = function (fn) { this._onTouchedCallback = fn; };
    IgxRadio.decorators = [
        { type: Component, args: [{
                    providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: IgxRadio, multi: true }],
                    selector: "igx-radio",
                    styles: [".igx-control__radio ~ .igx-control__label{display:inline-block;position:relative;cursor:pointer;height:20px;line-height:20px;font-size:1em;color:rgba(0,0,0,0.87);padding-left:1.5em;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.igx-control__radio ~ .igx-control__label::before,.igx-control__radio ~ .igx-control__label::after{position:absolute;content:'';width:20px;height:20px;left:0;border-radius:50% 50%}.igx-control__radio ~ .igx-control__label::before{-webkit-backface-visibility:hidden;backface-visibility:hidden;-webkit-transform:translateZ(0);transform:translateZ(0);-webkit-transition:all 0.2s ease-in;-o-transition:all 0.2s ease-in;transition:all 0.2s ease-in}.igx-control__radio:not(:checked) ~ .igx-control__label::before{-webkit-transform:scale3d(0, 0, 0);transform:scale3d(0, 0, 0)}.igx-control__radio:not(:checked) ~ .igx-control__label::after{border:2px solid rgba(0,0,0,0.54)}.igx-control__radio:checked ~ .igx-control__label::before{border:2px solid #e41c77;background-color:#e41c77;-webkit-transform:scale3d(0.5, 0.5, 0.5);transform:scale3d(0.5, 0.5, 0.5)}.igx-control__radio:checked ~ .igx-control__label::after{border:2px solid #e41c77}.igx-control__radio:disabled ~ .igx-control__label{pointer-events:none;color:rgba(0,0,0,0.38)}.igx-control__radio:disabled:not(:checked) ~ .igx-control__label::after{border:2px solid rgba(0,0,0,0.38)}.igx-control__radio:disabled:checked ~ .igx-control__label::before{background-color:rgba(0,0,0,0.38);border:2px solid transparent}.igx-control__radio:disabled:checked ~ .igx-control__label::after{border:2px solid rgba(0,0,0,0.38)}.igx-control{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-webkit-box-pack:justify;-ms-flex-pack:justify;justify-content:space-between;padding:8px 0}.igx-control__radio{margin:0;position:absolute;opacity:0;z-index:-1;width:0;height:0;left:0;overflow:hidden;pointer-events:none}"],
                    template: "<div class=\"igx-control\">     <input class=\"igx-control__radio\" type=\"radio\" #radio         [attr.id]=\"id\"         [attr.name]=\"name\"         [attr.value]=\"value\"         [attr.tabindex]=\"tabindex\"         [attr.aria-checked]=\"checked\"         [disabled]=\"disabled\"         [checked]=\"checked\"         (change)=\"onChange($event)\"         (focus)=\"onFocus($event)\"         (blur)=\"onBlur($event)\"/>     <label class =\"igx-control__label\" [attr.for]=\"id\"><ng-content></ng-content></label> </div>"
                },] },
    ];
    /** @nocollapse */
    IgxRadio.ctorParameters = function () { return []; };
    IgxRadio.propDecorators = {
        "value": [{ type: Input },],
        "id": [{ type: Input },],
        "name": [{ type: Input },],
        "disabled": [{ type: Input },],
        "tabindex": [{ type: Input },],
        "change": [{ type: Output },],
        "nativeRadio": [{ type: ViewChild, args: ["radio",] },],
    };
    return IgxRadio;
}());
export { IgxRadio };
var IgxRadioModule = /** @class */ (function () {
    function IgxRadioModule() {
    }
    IgxRadioModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [IgxRadio],
                    exports: [IgxRadio]
                },] },
    ];
    /** @nocollapse */
    IgxRadioModule.ctorParameters = function () { return []; };
    return IgxRadioModule;
}());
export { IgxRadioModule };
export { ɵ0 };
//# sourceMappingURL=radio.component.js.map