import { AfterViewInit, ElementRef, EventEmitter, QueryList } from "@angular/core";
export declare class IgxTabBar implements AfterViewInit {
    private _element;
    tabs: QueryList<IgxTab>;
    panels: QueryList<IgxTabPanel>;
    onTabSelected: EventEmitter<{}>;
    onTabDeselected: EventEmitter<{}>;
    selectedIndex: number;
    readonly itemStyle: string;
    private _itemStyle;
    readonly selectedTab: IgxTab;
    constructor(_element: ElementRef);
    ngAfterViewInit(): void;
    _selectedPanelHandler(args: any): void;
    private _deselectPanel(panel);
}
export declare class IgxTabPanel {
    private _tabBar;
    isSelected: boolean;
    label: string;
    icon: string;
    isDisabled: boolean;
    readonly itemStyle: string;
    private _itemStyle;
    readonly relatedTab: IgxTab;
    readonly index: number;
    constructor(_tabBar: IgxTabBar);
    select(): void;
}
export declare class IgxTab {
    private _tabBar;
    private _element;
    relatedPanel: IgxTabPanel;
    private _changesCount;
    readonly changesCount: number;
    readonly isDisabled: boolean;
    readonly isSelected: boolean;
    readonly index: number;
    constructor(_tabBar: IgxTabBar, _element: ElementRef);
    select(): void;
}
export declare class IgxTabBarModule {
}
